//////////////////////////////////////////////////////////////
//	: gprtmpi.cpp										//
//	    API MPI			      	//
//	Copyright (c) 2011  ,  	//
//////////////////////////////////////////////////////////////

#include "tbag.h"
#include <queue>

namespace Taskbag {

TBag::TBag(int num_prc,int argc, char* argv[])
{
	MPI_Init(&argc, &argv);
	nproc=num_prc;
}

TBag::~TBag()
{
	int rank;
	MPI_Comm_rank(MPI_COMM_WORLD,&rank);
	MPI_Finalize();
	if (rank!=0){exit(0);}
}

void TBag::Task::send(void*p,size_t s)
{
	int rank;
	MPI_Comm_rank(MPI_COMM_WORLD,&rank);

	//printf("\nsize=%d r=%d bs=%d %d\n",s,rank,size,buf);
	while/*!*/(cur+s>size){buf=realloc(buf,size+ALLOC_SIZE);size+=ALLOC_SIZE;}
	memmove(buf,p,s);cur+=s;
}

void TBag::Task::recv(void*p,size_t s)
{
	memmove(p,(char*)buf/*?*/+cur,s);cur+=s;
}

MPI_Comm getMPICommWorkspace(){return MPI_COMM_WORLD;}

void TBag::run()
{
	int rank;
	MPI_Comm_rank(MPI_COMM_WORLD,&rank);
	MPI_Comm_size(MPI_COMM_WORLD,&nproc);
	
	cur_task=0;
	c_active=0;
	/**///assert(nproc>1);
	
	TBag::Task* task=createTask();
	controlWord=ControlWord_WaitForTask;
	
	if (rank==0){
		//printf("iamgod%d  %d\n",rank,nproc);
		TBag* b=this;
		for (int i=1;i<nproc;i++){
			MPI_Request reqw;
			MPI_Isend(&controlWord,1,MPI_INT,i,My_MPI_TAG_ControlWord,MPI_COMM_WORLD,&reqw);
		}
		//b->req=new MPI_Request[b->nproc];
		std::queue<int> idle;
		b->c_active=0;
		for(b->c_active=1;b->c_active<b->nproc && b->if_job();b->c_active++){
			//MPI_Request tempreqw;
			b->get(task);
			controlWord=ControlWord_InputTask;
			MPI_Send(&controlWord,1,MPI_INT,b->c_active,My_MPI_TAG_ControlWord,getMPICommWorkspace()/*,&tempreqw*/);
			task->toproc=b->c_active;task->cur=0;task->send_task();
			MPI_Send(&task->size,1,MPI_INT,b->c_active,My_MPI_TAG_BufSize,getMPICommWorkspace()/*,&tempreqw*/);

			//printf("\nAllaharbar %d\n",task->buf);
			MPI_Send(task->buf,task->cur,MPI_BYTE,b->c_active,My_MPI_TAG_Task,getMPICommWorkspace()/*,&tempreqw*/);
			//printf("\nAllaharbar2 %d\n",task->buf);
		}
		b->c_active--;
		for(int i=b->c_active;i<b->nproc;i++)idle.push(i);
	
		while(b->c_active||b->if_job()){
			//printf("\nAllsdghsdg %d %d\n",b->if_job(),b->c_active);
			while(idle.size() && b->if_job()){
				int prc=idle.front();
				idle.pop();	
				MPI_Request tempreqw;
				b->get(task);
				controlWord=ControlWord_InputTask;
				MPI_Isend(&controlWord,1,MPI_INT,prc,My_MPI_TAG_ControlWord,getMPICommWorkspace(),&tempreqw);
				task->toproc=prc;task->cur=0;task->send_task();
				MPI_Isend(&task->size,1,MPI_INT,prc,My_MPI_TAG_BufSize,getMPICommWorkspace(),&tempreqw);
				MPI_Isend(task->buf,task->cur,MPI_BYTE,prc,My_MPI_TAG_Task,getMPICommWorkspace(),&tempreqw);
				//send_task(prc,&tsk);
				b->c_active++;
			}
			int prc;
	
			MPI_Status sta;
			//MPI_Recv(&controlWord,1,MPI_INT,MPI_ANY_SOURCE,My_MPI_TAG_ControlWord,getMPICommWorkspace(),&sta);
			size_t bsize=0;
			MPI_Recv(&bsize,1,MPI_INT,MPI_ANY_SOURCE,My_MPI_TAG_BufSize,getMPICommWorkspace(),&sta);
			prc=sta.MPI_SOURCE;
			
			if(bsize>(task->size)){
//				printf("sadgsdiugh\n%d %d\n\tsdg\n",bsize,task->size);
				task->buf=realloc(task->buf,bsize);
//				printf("sadgsdiugh2");
				task->size=bsize;
			}
			//printf("\nAllsdghsdg %d\n",task->buf);

			MPI_Recv(task->buf,bsize,MPI_BYTE,prc,My_MPI_TAG_Result,getMPICommWorkspace(),&sta);
			task->fromproc=prc;task->cur=0;task->recv_result();	
			b->put(task);
			b->c_active--;
			idle.push(prc);
			//put(&res);
		}

		for(int i=1;i<nproc;i++){
			//MPI_Request tempreqw;
			controlWord=ControlWord_End;
			MPI_Send(&controlWord,1,MPI_INT,i,My_MPI_TAG_ControlWord,getMPICommWorkspace()/*,&tempreqw*/);
		}

	}else{
//printf("iamslave%d  %d\n",rank,nproc);
		sta=new MPI_Status;
		bool flag=true;
		size_t bsize=0;
		while (flag){
			MPI_Recv(&controlWord,1,MPI_INT,0,My_MPI_TAG_ControlWord,MPI_COMM_WORLD,sta);
			//printf("igiveit %d  \n",controlWord);
			switch (controlWord){
				case ControlWord_WaitForTask:break;
				case ControlWord_InputTask:
					MPI_Status sta;

					//MPI_Recv(&controlWord,1,MPI_INT,0,My_MPI_TAG_ControlWord,getMPICommWorkspace(),&sta);
					
					MPI_Recv(&bsize,1,MPI_INT,0,My_MPI_TAG_BufSize,getMPICommWorkspace(),&sta);
					if(bsize>task->size){task->buf=realloc(task->buf,bsize);task->size=bsize;}
					MPI_Recv(task->buf,bsize,MPI_BYTE,0,My_MPI_TAG_Task,getMPICommWorkspace(),&sta);
					task->controlWord=controlWord;task->toproc=rank;task->cur=0;task->recv_task();
					proc(task);////////////////////////
					controlWord=ControlWord_Result;task->controlWord=controlWord;
					task->toproc=rank;task->cur=0;task->send_result();
					MPI_Send(&controlWord,1,MPI_INT,0,My_MPI_TAG_ControlWord,getMPICommWorkspace());
					MPI_Send(&task->size,1,MPI_INT,0,My_MPI_TAG_BufSize,getMPICommWorkspace());
					MPI_Send(task->buf,task->cur,MPI_BYTE,0,My_MPI_TAG_Result,getMPICommWorkspace());
					break;
				case ControlWord_End:flag=false;
				default:flag=controlWord!=ControlWord_End;
			}
		}
		
		delete sta;
	}
	MPI_Barrier(getMPICommWorkspace());
	delete task;
}

}
