//////////////////////////////////////////////////////////////
//	: tbag.h											//
//	    API MPI		      		//
//	Copyright (c) 2011  , 		//
//////////////////////////////////////////////////////////////

#ifndef _TASK_BAG_RUN_TIME
#define _TASK_BAG_RUN_TIME

#include <mpi.h>
#include <malloc.h>

namespace Taskbag {

#define My_MPI_TAG_ControlWord 0
#define My_MPI_TAG_BufSize 1
#define My_MPI_TAG_Task 2
#define My_MPI_TAG_Result 3
#define ControlWord_WaitForTask 0
#define ControlWord_InputTask 1
#define ControlWord_Result 2
#define ControlWord_End 3

#define ALLOC_SIZE 1024

class TBag{
public:
	class Task{
	public:
		Task(){size=ALLOC_SIZE;cur=0;buf=malloc(size);}

		virtual~Task(){free(buf);}
		void send(void*,size_t);
		void recv(void*,size_t);

		virtual void send_task()=0;
		virtual void recv_task()=0;
		virtual void send_result()=0;
		virtual void recv_result()=0;
		/**/
		int fromproc,toproc;
		void*  buf;
		size_t size;
		size_t cur;
		int mycurproc, numprocs;
		int controlWord;
		MPI_Request* req;
		MPI_Request* curreq;
		/**/
	};
public:
	TBag(int num_prc,int argc, char* argv[]);
	virtual ~TBag();
	virtual Task* createTask()=0;
	
	void run();
	virtual bool if_job()=0;
	virtual void put(Task*)=0;
	virtual void get(Task*)=0;
	virtual void proc(Task*)=0;

private:
	/**/
	MPI_Request* req;
	MPI_Request* curreq;
	MPI_Status* sta;
	int controlWord;
//int rank;
	/**/
	int nproc;
	volatile int c_active;
	volatile int cur_task;
};

}
#endif
