/*$TET$ringmult$!templet!*/
/*
~Link=
	+BEG ? col -> PROC;
	PROC ! ready ->BEG.
  
*Proc=
	l : Link ? col -> proc;
	r : Link ! ready -> send;
	+beg(r!col)->proc;
	send(r?ready,r!col)->proc;
	proc(l?col,l!ready)->send.
  
*/
/*$TET$*/

#include "ringmult.h"

namespace ringmult{
/*$TET$ringmult$!globals!*/
/*$TET$*/
//////////////////////class Link////////////////////
Link::Link(TEMPLET::Assemble*a):TEMPLET::Channel(a)
{
	_state=_st_BEG;
	_sent=_no_snt;
/*$TET$Link$!constructor!*/
/*$TET$*/
}

Link::~Link()
{
/*$TET$Link$!destructor!*/
/*$TET$*/
}

void Link::_send_col()
{
	assert( _state==_st_BEG || true );
	_sent=_snt_col;
	if(_state==_st_BEG){_state=_st_PROC;_active=RTL_SRV;}
	_send();
}

void Link::_send_ready()
{
	assert( _state==_st_PROC || true );
	_sent=_snt_ready;
	if(_state==_st_PROC){_state=_st_BEG;_active=RTL_CLI;}
	_send();
}

//////////////////////class Proc////////////////////
Proc::Proc(TEMPLET::Assemble*a):TEMPLET::Process(a)
{
	_l=0;
	_r=0;
	_entry=_createActivator();_entry->_send(_method_beg);
/*$TET$Proc$!constructor!*/
/*$TET$*/
}

Proc::~Proc()
{
	delete _entry;
/*$TET$Proc$!destructor!*/
/*$TET$*/
}

/*$TET$Proc$!usercode!*/
/*$TET$*/

bool Proc::beg(/*out*/Link::col*p1)
{
/*$TET$Proc$beg*/
	for(int i=0;i<N;i++) p1->b[i]=b[i];
	p1->c=col;
	empty=true;
	return true;
/*$TET$*/
}

bool Proc::send(/*in*/Link::ready*p1,/*out*/Link::col*p2)
{
/*$TET$Proc$send*/
	if(empty)return false;
	for(int i=0;i<N;i++) p2->b[i]=b[i];
	p2->c=col;
	empty=true;
	return true;
/*$TET$*/
}

bool Proc::proc(/*in*/Link::col*p1,/*out*/Link::ready*p2)
{
/*$TET$Proc$proc*/
	if(n==N || !empty)return false;

	for(int i=0;i<N;i++)b[i]=p1->b[i];
	col=p1->c;
	empty=false;

	c[col]=0.0;
	for(int i=0;i<N;i++)c[col]+=a[i]*b[i];

	cout<<"c("<<row<<","<<col<<")="<<c[col]<<" ";
	n++;
	
	return true;
/*$TET$*/
}

void Proc::_run(int _selector,TEMPLET::Channel*_channel)
{
	bool res;
/*$TET$Proc$!run!*/
/*$TET$*/
	for(;;){
		switch(_selector){
			case _port_l://
				if(_l->_s_in_col()){_selector=_method_proc;break;};
				assert(0);
				return;
			case _port_r://
				if(_r->_c_in_ready()){_selector=_method_send;break;};
				assert(0);
				return;
			case _method_beg:
				res=(_r->_c_out_col());
				if(res)res=beg(_r->_get_col());
				if(res)_r->_send_col();
				if(res){_selector=_method_proc;break;}
				return;
			case _method_send:
				res=(_r->_c_in_ready()&&_r->_c_out_col());
				if(res)res=send(_r->_get_ready(),_r->_get_col());
				if(res)_r->_send_col();
				if(res){_selector=_method_proc;break;}
				return;
			case _method_proc:
				res=(_l->_s_in_col()&&_l->_s_out_ready());
				if(res)res=proc(_l->_get_col(),_l->_get_ready());
				if(res)_l->_send_ready();
				if(res){_selector=_method_send;break;}
				return;
			default: assert(0); return;
		}
	}
}

//////////////////////class ringmult////////////////////
ringmult::ringmult(int NT): TEMPLET::Assemble(NT)
{
/*$TET$ringmult$!constructor!*/
/*$TET$*/
}

ringmult::~ringmult()
{
/*$TET$ringmult$!destructor!*/
/*$TET$*/
}

}
/*$TET$ringmult$!usercode!*/
int main(int,char**)
{
	//   

	double a[N][N],b[N][N],c[N][N];

	cout<<"A=\n";
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			a[i][j]=N*i+j;
			cout<<a[i][j]<<" ";
		}
		cout<<"\n";
	}

	cout<<"\nB=\n";
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			b[i][j]=N*i+j;
			cout<<b[i][j]<<" ";
		}
		cout<<"\n";
	}
	
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			c[i][j]=0.0;
			for(int k=0;k<N;k++)c[i][j]+=a[i][k]*b[k][j];
		}
	}

	cout<<"\nC=\n";
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			cout<<c[i][j]<<" ";
		}
		cout<<'\n';
	}

	cout<<"--------------------------------\n";

	//      

	ringmult::ringmult t(4);

	//   / 
	ringmult::Link::cli* cli[N];
	ringmult::Link::srv* srv[N];
	
	ringmult::Proc* proc[N];

	
	for(int i=0;i<N;i++){
		//     / 
		t.new_Link(cli[i],srv[i]);
		
		//    
		proc[i]=t.new_Proc();

		proc[i]->row=i;
		proc[i]->col=i;
		proc[i]->n=0;
		proc[i]->empty=false;
	}

	//    
	for(int i=0;i<N;i++)proc[i]->p_r(cli[i]);

	for(int i=0;i<N-1;i++)proc[i+1]->p_l(srv[i]);
	proc[0]->p_l(srv[N-1]);
	
	//  
	cout<<"A=\n";
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			proc[i]->a[j]=N*i+j;
			cout<<proc[i]->a[j]<<" ";
		}
		cout<<"\n";
	}
	
	cout<<"\nB=\n";
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			proc[j]->b[i]=N*i+j;
			cout<<proc[j]->b[i]<<" ";
		}
		cout<<"\n";
	}

	//  
	t.run();

	//  
	cout<<"\nC=\n";
	for(int i=0;i<N;i++){
		for(int j=0;j<N;j++){
			cout<<proc[i]->c[j]<<" ";
		}
		cout<<'\n';
	}

	return 0;
}
/*$TET$*/

