#ifndef _TEMPLET_MODULE_templet
#define _TEMPLET_MODULE_templet

#include <string.h>
#include <assert.h>

#include "tet.h"

/*$TET$templet$!include!*/
#include <iostream>
using namespace std;
/*$TET$*/

namespace templet{

class Link:public TEMPLET::Channel{
public:
	Link(TEMPLET::Assemble*a);
	~Link();
public:
	struct cli{Link*c;}_cli;
	struct srv{Link*c;}_srv;
public:
	struct agrSin2{//<Begin> 
/*$TET$Link$agrSin2*/
	double x;
/*$TET$*/
	};
	struct argCos2{//<Begin> 
/*$TET$Link$argCos2*/
	double x;
/*$TET$*/
	};
	struct result{//<Calc> 
/*$TET$Link$result*/
	double y;
/*$TET$*/
	};
public:
	void _send_agrSin2();
	void _send_argCos2();
	void _send_result();
public:
	agrSin2* _get_agrSin2(){return &_mes_agrSin2;}
	argCos2* _get_argCos2(){return &_mes_argCos2;}
	result* _get_result(){return &_mes_result;}
private:
	Link::agrSin2  _mes_agrSin2;
	Link::argCos2  _mes_argCos2;
	Link::result  _mes_result;
private:
	enum _state_Iface{
		_st_Begin,
		_st_Calc,
		_st_End
	};
	enum _sent_Iface{_no_snt,
		_snt_agrSin2,
		_snt_argCos2,
		_snt_result
	};
private:
	enum _state_Iface _state;
	enum _sent_Iface _sent;
public:
	// access tests for message 'agrSin2'
	bool _s_in_agrSin2(){return _active==SRV && _sent==_snt_agrSin2;}
	bool _c_in_agrSin2(){return _active==CLI && _sent==_snt_agrSin2;}
	bool _s_out_agrSin2(){return _active==SRV && (false);}
	bool _c_out_agrSin2(){return _active==CLI && (_state==_st_Begin||false);}
	// access tests for message 'argCos2'
	bool _s_in_argCos2(){return _active==SRV && _sent==_snt_argCos2;}
	bool _c_in_argCos2(){return _active==CLI && _sent==_snt_argCos2;}
	bool _s_out_argCos2(){return _active==SRV && (false);}
	bool _c_out_argCos2(){return _active==CLI && (_state==_st_Begin||false);}
	// access tests for message 'result'
	bool _s_in_result(){return _active==SRV && _sent==_snt_result;}
	bool _c_in_result(){return _active==CLI && _sent==_snt_result;}
	bool _s_out_result(){return _active==SRV && (_state==_st_Calc||false);}
	bool _c_out_result(){return _active==CLI && (false);}
};

class Parent:public TEMPLET::Process{
public:
	Parent(TEMPLET::Assemble*a);
	~Parent();
private:
	//methods
	bool fork(/*out*/Link::argCos2*p1,/*out*/Link::argSin2*p2);
	bool join(/*in*/Link::result*p1,/*in*/Link::result*p2);

/*$TET$Parent$!userdata!*/
/*$TET$*/

public:
	enum{
		_port_p1,
		_port_p2,
		_method_fork,
		_method_join
	};
public:
	void p_p1(Link::cli*p){_p1=(Link*)p->c;_p1->_cliPort=this;_p1->_cli_selector=_port_p1;}
	void p_p2(Link::cli*p){_p2=(Link*)p->c;_p2->_cliPort=this;_p2->_cli_selector=_port_p2;}
protected:
	virtual void _run(int _selector,TEMPLET::Channel*_channel);
private:
	// ports
	Link* _p1;
	Link* _p2;
	// initial activator
	TEMPLET::Activator* _entry;
};

class Child:public TEMPLET::Process{
public:
	Child(TEMPLET::Assemble*a);
	~Child();
private:
	//methods
	bool calcCos2(/*in*/Link::argCos2*p1,/*out*/Link::result*p2);
	bool calcSin2(/*in*/Link::argSin2*p1,/*out*/Link::result*p2);

/*$TET$Child$!userdata!*/
/*$TET$*/

public:
	enum{
		_port_p,
		_method_calcCos2,
		_method_calcSin2
	};
public:
	void p_p(Link::srv*p){_p=(Link*)p->c;_p->_srvPort=this;_p->_srv_selector=_port_p;}
protected:
	virtual void _run(int _selector,TEMPLET::Channel*_channel);
private:
	// ports
	Link* _p;
	// initial activator
};

class templet:public TEMPLET::Assemble{
public:
	templet(int NT);
	~templet();

/*$TET$templet$!userdata!*/
/*$TET$*/
public:
	Parent*new_Parent(){Parent*p=new Parent(this);_regProc(p);return p;}
	Child*new_Child(){Child*p=new Child(this);_regProc(p);return p;}
	void new_Link(Link::cli*&c,Link::srv*&s){Link*ch=new Link(this);_regChan(ch);
		ch->_cli.c=ch->_srv.c=ch;c=&ch->_cli;s=&ch->_srv;}
};

}
#endif
